{*******************************************************************************
    Ԫƣ PHPWebDm.pas

    Ԫ˵ Delphi ͬPHP webͨŽӿڡ PHP۵PHP˺ܶ

    ʱ䣺 Chenshilong, 2012-5-13
*******************************************************************************}


unit PHPWebDm;

interface

uses
  SysUtils, Classes, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, CslJson;

type
  // WebӳɹWebʧܡ¼ʧܡûҪϲȫ
  TLoginType = (ltCon, ltDisCon, ltLoginFail, ltUpdate, ltIncomplete);

  TPHPWeb = class(TDataModule)
    IdHTTP: TIdHTTP;
    procedure DataModuleCreate(Sender: TObject);
  private
    // Զ̷ʱ
    FServerDateTime: TDateTime;
    FUserID: Integer;
    FAccount: string;
    FRealName: string;
    FUserFlag: Integer; // û־λֳһûơ
    FMeasureURL: string;  // http://d.jl.smartcost.com.cn/api/client/
    FLoginURL: string;
    FLoginBannerURL: string;
    FCheckOnLineURL: string;
    FPassportURL: string;
    FPwdURL: string;
    FRegURL: string;
    FWebLoginURL: string;
    FServerDateTimeURL: string;
    FWebSoftURL: string;
    FLogoutURL: string;
    FRole: string;
    FCompany: string;
    FUserImageURL: string;
    FLoginCloudURL: string;

    procedure SetUserID(const Value: Integer);
    procedure SetAccount(const Value: string);
    procedure SetRealName(const Value: string);

{-------------------------------------------------------------------------------
  :   CustomSearch()

  :   ͨõĲѯӿڣָ֮ɣ漶ţBۺ㷨ŶҮ ^__^

          ֵ
            -1           粻ͨ
             0           ͨ¼ѯҳȣ޷Լ
                           Jsonʽͨһƪ룻
             1           ɹ(¼)

          
             AURL        ַ
             AInFields   ļ֡
             AInValues   ļֵ
             AResultType ֵͣ0 һά飻1 ضά飻2 ߶
             AOutStrs    ڴ洢صɢֵҪֶ롣
             AOutRecords ڴ洢صĶ¼ݱֻ趨
                           С͸ֵJson飬ֵΪ'info'ֵ

          Ҫ
             ٷصJsonбstatusmsg֣Լʽ
             AResultsһԪأ洢ֵΪ0ʱѯԭ


  :   Chenshilong, 2014-07-13
-------------------------------------------------------------------------------}
    function CustomSearch(AURL: string; AInFields, AInValues: array of string;
      AResultType: Integer; var AOutStrs: array of string;
      var AOutRecords: TOVArr): Integer;
  public
    function SystemDateTime: TDateTime;
    function Search(AURL: string; AInFields, AInValues: array of string; var AOutStrs: array of string): Integer; overload;
    function Search(AURL: string; AInFields, AInValues: array of string; var AOutRecords: TOVArr): Integer; overload;
    function Search(AURL: string; AInFields, AInValues: array of string; var AOutStrs: array of string ; var AOutRecords: TOVArr): Integer; overload;
    function Search(AURL: string; AInFields, AInValues: array of string; AResultType: Integer; var AOutStrs: array of string ; var AOutRecords: TOVArr): Integer; overload;
    function Login(AAccount, APW: string; var AInfo, ACheckCode: string): TLoginType;
    function ConnectServer(AIP: string; var ACompanyName: string): Integer;  // װȵIP
    function UpDataFile(AUserID, ATenderID, APhaseNo: Integer; AFile, AMD5_JL: string;
      AIsSubmit: Boolean; var AResultStr: string; ACheckPassed: Boolean; ACheckerMemo: string): Boolean;
    function UpAttachmentFile(AUperID, AWebID, ABillID: Integer; AFile,
      ACategory, AMemo, APhaseName: string; var ANewFileName: string): Boolean;
    function GetAttachmentFileList(AWebID: Integer; var vArr: TOVArr): Boolean;
    function zip(AFileArr: array of string): string;
    function CheckZip(AZipFile: string; AFileCount: Integer): Boolean;   // zipǷܹȷѹļ
    function TempName(ALength: Integer = 12): string;
    function WebPath: string;
    function UserPath: string;
    // ļԴļַ洢صλ
    function DownFile(ASourceURL: string; var ALocalFile: string): Boolean;
    // ڵֵ(ЩԻлʱʱ)
    procedure Debug(AFileName, AStr: string); overload;
    procedure Debug(AFileName: string; AInFields, AInValues: array of string); overload;
    function NetError(AMid: string): string;
    function PageError(AMid: string): string;
    function ExistInServer(AWebID: Integer): Boolean;


    property Account: string read FAccount write SetAccount;
    property UserID: Integer read FUserID write SetUserID;
    property RealName: string read FRealName write SetRealName;
    property UserFlag: Integer read FUserFlag write FUserFlag;
    property Company: string read FCompany write FCompany;
    property Role: string read FRole write FRole;

    property MeasureURL: string read FMeasureURL;
    property WebSoftURL: string read FWebSoftURL;
    property PassportURL: string read FPassportURL;
    property LoginURL: string read FLoginURL;
    property WebLoginURL: string read FWebLoginURL;
    property LoginBannerURL: string read FLoginBannerURL;
    property LogoutURL: string read FLogoutURL;
    property RegURL: string read FRegURL;
    property PwdURL: string read FPwdURL;
    property CheckOnLineURL: string read FCheckOnLineURL;
    property ServerDateTimeURL: string read FServerDateTimeURL;
    property UserImageURL: string read FUserImageURL write FUserImageURL;
    property LoginCloudURL: string read FLoginCloudURL write FLoginCloudURL;

  end;


function PHPWeb: TPHPWeb;
// ȫ  㶫  Ԥ Ű  ۿˮ  ںӺ  迣 嵥
function ExeCategoryName: string;

implementation

uses
  MD5Unit, IdMultipartFormData, VCLUnZip, VCLZip,
  IniFiles, Forms, UtilMethods, Variants, ConstUnit{, Controls, Windows};

var g_PHPWeb: TPHPWeb;

{$R *.dfm}

{ TPHPWeb }

function PHPWeb: TPHPWeb;
begin
  if g_PHPWeb = nil then
    g_PHPWeb := TPHPWeb.Create(nil);
  Result := g_PHPWeb;
end;

function ExeCategoryName: string;
begin
  Result := 'JLZF';
end;

function TPHPWeb.Login(AAccount, APW: string; var AInfo, ACheckCode: string): TLoginType;
var vArr: array of string;
begin
  vArr := VarArrayOf(['uid', 'name', 'email', 'ucompany', 'jobtitle', 'avatar', 'msg']);
  case Search(FMeasureURL + 'signin', ['v3name', 'v3pass'], [AnsiToUtf8(AAccount), APW], vArr) of
    -1: Result := ltDisCon;
    0:
    begin
      AInfo := vArr[0];
      Result := ltLoginFail;
    end;
    1:
    begin
      FUserID := StrToInt(vArr[0]);
      FRealName := vArr[1];
      FAccount := AAccount;  // vArr[2]
      FCompany := vArr[3];
      FRole := vArr[4];
      FUserImageURL := vArr[5];
      AInfo := vArr[6];
      Result := ltCon;
    end;
  end;
end;

procedure TPHPWeb.SetUserID(const Value: Integer);
begin
  FUserID := Value;
end;

procedure TPHPWeb.SetAccount(const Value: string);
begin
  FAccount := Value;
end;

procedure TPHPWeb.DataModuleCreate(Sender: TObject);
var ini: TIniFile;
begin
  FServerDateTime := -1;

  ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Cloud.ini');
  try
//    FMeasureURL := ini.ReadString('URL', 'MeasureURL', '');
    FMeasureURL := 'http://' + ini.ReadString('URL', 'Server', '') +
      ini.ReadString('URL', 'MeasureURL', '');
    FWebSoftURL := ini.ReadString('URL', 'WebSoftURL', '');
    FPassportURL := ini.ReadString('URL', 'PassportURL', '');
    FLoginCloudURL := ini.ReadString('URL', 'LoginCloudURL', '');

    FLoginURL := FWebSoftURL + ini.ReadString('URL', 'LoginURL', '');
    FWebLoginURL := FWebSoftURL + ini.ReadString('URL', 'FWebLoginURL', '');
    FLoginBannerURL := FWebSoftURL + ini.ReadString('URL', 'LoginBannerURL', '');
    FLogoutURL := FWebSoftURL + ini.ReadString('URL', 'LogoutURL', '');
    FRegURL := FPassportURL + ini.ReadString('URL', 'RegURL', '');
    FPwdURL := FPassportURL + ini.ReadString('URL', 'PwdURL', '');
    FCheckOnLineURL := FWebSoftURL + ini.ReadString('URL', 'CheckOnLineURL', '');
    FServerDateTimeURL := FWebSoftURL + ini.ReadString('URL', 'ServerDateTimeURL', '');
  finally
    ini.Free;
  end;
end;

procedure TPHPWeb.SetRealName(const Value: string);
begin
  FRealName := Value;
end;

function TPHPWeb.zip(AFileArr: array of string): string;
var vZip: TVCLZip;
  sAppFile, sZipFile: string;
  i: Integer;
begin
  Result := 'Error';
  sAppFile := AFileArr[Low(AFileArr)];
  sZipFile := ExtractFilePath(sAppFile) + ExtractFileNameWithoutExt(sAppFile) + '.up';

  if FileExists(sZipFile) then
      DeleteFile(sZipFile);

  vZip := TVCLZip.Create(nil);
  try
    for i := Low(AFileArr) to High(AFileArr) do
    begin
      if FileExists(AFileArr[i]) then
        vZip.FilesList.Add(AFileArr[i]);
    end;

    vZip.ZipName := sZipFile;
    // PHPֽ֧ѹzipļ
    //vZip.Password := 'jlzf.Sc.2014';
    vZip.Recurse := True;
    vZip.ZipComment := 'ݺ֧';
    vZip.OverwriteMode := Always;
    vZip.Zip;
    Result := sZipFile;

    for i := Low(AFileArr) to High(AFileArr) do
      DeleteFile(AFileArr[i]);
  finally
    vZip.Free;
  end;
end;

function TPHPWeb.CheckZip(AZipFile: string; AFileCount: Integer): Boolean;
var vUnZip: TVCLUnZip;
begin
  vUnZip := TVCLUnZip.Create(nil);
  try
    vUnZip.ZipName := AZipFile;
    vUnZip.DestDir := 'C:\Temp\MeasureTemp\';
    vUnZip.DoAll := True;
    vUnZip.RecreateDirs := True;
    vUnZip.RetainAttributes := True;
    vUnZip.OverwriteMode := Always;
    Result := (AFileCount = vUnZip.UnZip);
  finally
    DeleteFolder(vUnZip.DestDir);
    vUnZip.Free;
  end;
end;


function TPHPWeb.UpDataFile(AUserID, ATenderID, APhaseNo: Integer; AFile, AMD5_JL: string;
  AIsSubmit: Boolean; var AResultStr: string; ACheckPassed: Boolean; ACheckerMemo: string): Boolean;
var
  IdDataStream: TIdMultiPartFormDataStream;
  sResult, sURL: string;
  J: TCslJson;
  sZipMD5: string;
begin
  Result := False;

  if not FileExists(AFile) then Exit;

  IdDataStream := TIdMultiPartFormDataStream.Create;
  try
    if ACheckPassed then   // ͨ
    begin
      if AIsSubmit then
      begin
        sURL := Format('%speriod/%d/%d/%d/creat', [FMeasureURL, AUserID, ATenderID, APhaseNo])
      end
      else
      begin
        sURL := FMeasureURL + 'user/audit/measure';
        IdDataStream.AddFormField('userid', IntToStr(AUserID));
        IdDataStream.AddFormField('tenderid', IntToStr(ATenderID));
        IdDataStream.AddFormField('phaseno', IntToStr(APhaseNo));
        IdDataStream.AddFormField('CheckerMemo', ReplaceCharsForJson(ACheckerMemo));
      end;
    end
    else  // ˲ͨ
    begin
      sURL := Format('%suser/set/%d/%d/%d/checkno', [FMeasureURL, AUserID, ATenderID, APhaseNo]);
      IdDataStream.AddFormField('CheckerMemo', ReplaceCharsForJson(ACheckerMemo));
    end;

    IdDataStream.AddFile('upfile', AFile, 'text/plain');
    IdDataStream.AddFormField('upfile', AFile);
    IdDataStream.AddFormField('MD5_JL', AMD5_JL);
    sZipMD5 := MD5_File(AFile);
    IdDataStream.AddFormField('MD5_Zip', sZipMD5);

    IdDataStream.Position := 0;
    try
      sResult := IdHTTP.Post(sURL, IdDataStream);
    except
      Abort;
    end;
  finally
    IdDataStream.Free;
    DeleteFile(AFile);
  end;

  J := TCslJson.Create;
  try
    J.Text := Utf8ToAnsi(sResult);
    if SameText(J.Value['status'], 'true') then
      Result := True
    else
    begin
      Result := False;
      AResultStr := J.Value['msg'];
    end;
  finally
    J.Free;
  end;
end;

function TPHPWeb.Search(AURL: string; AInFields, AInValues: array of string; var AOutStrs: array of string): Integer;
var vA: TOVArr;
begin
  Result := CustomSearch(AURL, AInFields, AInValues, 0, AOutStrs, vA);
end;

function TPHPWeb.Search(AURL: string; AInFields, AInValues: array of string; var AOutRecords: TOVArr): Integer;
var vA: array of string;
begin
  Result := CustomSearch(AURL, AInFields, AInValues, 1, vA, AOutRecords);
end;

function TPHPWeb.Search(AURL: string; AInFields, AInValues: array of string; var AOutStrs: array of string; var AOutRecords: TOVArr): Integer;
begin
  Result := CustomSearch(AURL, AInFields, AInValues, 2, AOutStrs, AOutRecords);
end;

function TPHPWeb.Search(AURL: string; AInFields, AInValues: array of string; AResultType: Integer; var AOutStrs: array of string; var AOutRecords: TOVArr): Integer;
begin
  Result := CustomSearch(AURL, AInFields, AInValues, 3, AOutStrs, AOutRecords);
end;

function TPHPWeb.TempName(ALength: Integer): string;
const
  CodedBuf: array[0..35] of Char = ('0', '1', '2', '3', '4', '5',
  '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
  'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V',
  'W', 'X', 'Y', 'Z');
begin
  Result := '';
  Randomize;
  while Length(Result) < ALength do
    Result := Result + CodedBuf[Random(36)];
end;

function TPHPWeb.WebPath: string;
begin
  Result := ExtractFilePath(Application.ExeName) + 'Web\';
  if not DirectoryExists(Result) then
    ForceDirectories(Result);
end;

function TPHPWeb.UserPath: string;
begin
  Result := ExtractFilePath(Application.ExeName) + 'Web\Users\' + IntToStr(FUserID) + '\';
  if not DirectoryExists(Result) then
    ForceDirectories(Result);
end;

function TPHPWeb.DownFile(ASourceURL: string; var ALocalFile: string): Boolean;
var
  vStream: TMemoryStream;
  iFlag: Integer;
  bOK: Boolean;

  procedure SafeDownFile(ASourceURL: string; var ALocalFile: string);
  begin
    Inc(iFlag);
    bOK := False;
    try
      IdHTTP.Get(ASourceURL, vStream);
      vStream.SaveToFile(ALocalFile);
      bOK := True;
    except
      bOK := False;
    end;
  end;
begin
  iFlag := 0;
  bOK := False;
  Result := False;

  if Trim(ASourceURL) = '' then Exit;
  if Trim(ALocalFile) = '' then Exit;

  if (ExtractFileExt(ALocalFile) = '.rmf') and FileExists(ALocalFile) then
    DeleteFile(ALocalFile);

  vStream := TMemoryStream.Create;
  try
    while (not bOK) and (iFlag < 3) do   // 3
      SafeDownFile(ASourceURL, ALocalFile);

    Result := bOK;
  finally
    vStream.Free;
  end;
end;

function TPHPWeb.CustomSearch(AURL: string; AInFields,
  AInValues: array of string; AResultType: Integer;
  var AOutStrs: array of string; var AOutRecords: TOVArr): Integer;
var
  i: Integer;
  postList: TStrings;
  ssResponse: TStringStream;
  bDone: Boolean;
  vJson: TCslJson;
begin
  Result := -1;
  postList := TStringList.Create;
  ssResponse := TStringStream.Create('');
  try
    try
      for i := Low(AInFields) to High(AInFields) do
        postList.Add(Format('%s=%s', [AInFields[i], AInValues[i]]));

      IdHTTP.Post(AURL, postList, ssResponse);
      bDone := True;
    except
      bDone := False;
    end;

    if (bDone) and (Pos('200 OK', IdHTTP.ResponseText) <> 0) then   // ͨ
    begin
      vJson := TCslJson.Create;
      try
        vJson.Text := Utf8ToAnsi(ssResponse.DataString);

        if SameText(vJson.Value['status'], 'true') then          // ݶȡɹ
        begin
          case AResultType of
            0:
            begin
              for i := Low(AOutStrs) to High(AOutStrs) do
                AOutStrs[i] := vJson.Value[AOutStrs[i]];
            end;
            1:
            begin
              AOutRecords := vJson.ArrayValues('info');
            end;
            2:
            begin
              for i := Low(AOutStrs) to High(AOutStrs) do
                AOutStrs[i] := vJson.Value[AOutStrs[i]];

              AOutRecords := vJson.ArrayValues('info');
            end;
            3:
            begin
              vJson.ChildValues('info', AOutStrs);
              AOutRecords := vJson.ArrayValues('auditinfo');
            end;
          end;
          Result := 1;
        end
        else                                                     // ݶȡʧ
        begin
          case AResultType of
            0:
            begin
              AOutStrs[Low(AOutStrs)] := vJson.Value['msg'];
            end;
            1:
            begin
              SetLength(AOutRecords, 1, 1);
              AOutRecords[0, 0] := vJson.Value['msg'];
            end;
            2, 3:
            begin
              AOutStrs[Low(AOutStrs)] := vJson.Value['msg'];

              SetLength(AOutRecords, 1, 1);
              AOutRecords[0, 0] := vJson.Value['msg'];
            end;
          end;
          Result := 0;
        end;
      finally
        vJson.Free;
      end;
    end;
  finally
    postList.Free;
    ssResponse.Free;
  end;
end;

function TPHPWeb.SystemDateTime: TDateTime;
begin
  Result := Now;
end;

function TPHPWeb.NetError(AMid: string): string;
begin
  Result := Format('ǰ״̬ϲ(-1)%s³Իµ¼ٳԣ', [AMid]);
end;

function TPHPWeb.PageError(AMid: string): string;
begin
  Result := Format('Webҳش(0)%s³Իϵݺͷ', [AMid]);
end;

procedure TPHPWeb.Debug(AFileName, AStr: string);
var vSL: TStringList;
  sAdd: string;
begin
  vSL := TStringList.Create;
  try
    sAdd := Format('%s%d %s %s', [#10#13#10#13#10#13#10#13#10#13,
      UserID, RealName, Account]);

    vSL.Add(AStr + sAdd);

    if Pos('Debug_', AFileName) = 0 then
      AFileName := 'Debug_' + AFileName;

    vSL.SaveToFile(WebPath + AFileName + '.txt');
  finally
    vSL.Free;
  end;
end;

procedure TPHPWeb.Debug(AFileName: string; AInFields, AInValues: array of string);
var vSL: TStringList;
  sAdd: string;
  i: Integer;
begin
  if G_IsTest then
  begin
    vSL := TStringList.Create;
    try
      sAdd := Format('%s%d  %s  %s', [#10#13#10#13#10#13#10#13#10#13, UserID, RealName, Account]);

      for i := Low(AInFields) to High(AInFields) do
        vSL.Add(AInFields[i] + #9#9 + AInValues[i]);

      vSL.Add(sAdd);

      if Pos('Debug_', AFileName) = 0 then
        AFileName := 'Debug_' + AFileName;

      vSL.SaveToFile(WebPath + AFileName + '.txt');
    finally
      vSL.Free;
    end;
  end;
end;

function TPHPWeb.ConnectServer(AIP: string; var ACompanyName: string): Integer;
var vArr: array of string;
  sURL: string;
begin
  sURL := Format('http://%s/api/client/software/title', [AIP]);
  vArr := VarArrayOf(['msg']);
  Result := Search(sURL, [], [], vArr);
  case Result of
    -1: ACompanyName := 'ַ';
    0: ACompanyName := 'Webҳ';
    1: ACompanyName := vArr[0];
  end;
end;

function TPHPWeb.UpAttachmentFile(AUperID, AWebID, ABillID: Integer; AFile,
  ACategory, AMemo, APhaseName: string; var ANewFileName: string): Boolean;
var
  vMPFDS: TIdMultiPartFormDataStream;
  sResult, sURL: string;
  J: TCslJson;
  vArr: array of string;
begin
  Result := False;

  if not FileExists(AFile) then
  begin
//    Application.MessageBox(PChar(AFile + ' ļڣ'), '', MB_OK + MB_ICONERROR);
    Exit;
  end;

  vMPFDS := TIdMultiPartFormDataStream.Create;
  try
    sURL := Format('%stender/attachment/%d/%d/upload', [FMeasureURL, AWebID, AUperID]);
    vMPFDS.AddFile('upitem', AFile, 'text/plain');
    vMPFDS.AddFormField('itemid', IntToStr(ABillID));
    vMPFDS.AddFormField('Category', ACategory);
    vMPFDS.AddFormField('Memo', ReplaceCharsForJson(AMemo));
    vMPFDS.AddFormField('PhaseName', APhaseName);

    vMPFDS.Position := 0;
    try
      sResult := IdHTTP.Post(sURL, vMPFDS);
    except
      Abort;
    end;
  finally
    vMPFDS.Free;
  end;

  J := TCslJson.Create;
  try
    J.Text := Utf8ToAnsi(sResult);
    if SameText(J.Value['status'], 'true') then
    begin
      Result := True;
      vArr := VarArrayOf(['onlinefilename']);
      J.ChildValues('iteminfo', vArr);
      ANewFileName := vArr[0];
    end
    else
    begin
      Result := False;
    end;
  finally
    J.Free;
  end;
end;

function TPHPWeb.GetAttachmentFileList(AWebID: Integer; var vArr: TOVArr): Boolean;
var sURL: string;
begin
  sURL := Format('%stender/attachment/%d/list', [FMeasureURL, AWebID]);
  Result := Search(sURL, [], [], vArr) = 1;
end;

function TPHPWeb.ExistInServer(AWebID: Integer): Boolean;
var vArr: array of string;
  iResult: Integer;
  sSearchURL: string;
begin
  sSearchURL := Format('%stender/get/%d/exist', [PHPWeb.MeasureURL, AWebID]);
  vArr := VarArrayOf(['id', 'name']);
  iResult := PHPWeb.Search(sSearchURL, [''], [''], vArr);

  if (iResult = 1) and (High(vArr) >= 0) then
    Result := True
  else
    Result := False;
end;

initialization

finalization
  if g_PHPWeb <> nil then
    g_PHPWeb.Free;

end.
