program Measure_GuangDong;

{$R '..\..\res\uac.res' '..\..\res\uac.rc'}

uses
  Windows,
  ShareMem,
  Forms,
  MainFrm in '..\..\Forms\MainFrm.pas' {MainForm},
  ProjectManagerFme in '..\..\Frames\ProjectManagerFme.pas' {ProjectManagerFrame: TFrame},
  UtilMethods in '..\..\Units\UtilMethods.pas',
  ProjectManagerDm in '..\..\DataModules\ProjectManagerDm.pas' {ProjectManagerData: TDataModule},
  Connections in '..\..\Units\Connections.pas',
  TransFile in '..\..\Units\TransFile.pas',
  ZhAPI in '..\..\Units\ZhAPI.pas',
  CompactDB in '..\..\Units\CompactDB.pas',
  OpenProjectManager in '..\..\Units\OpenProjectManager.pas',
  ProjectData in '..\..\Units\ProjectData.pas',
  UpdateDataBase in '..\..\Units\UpdateDataBase.pas',
  DataBaseTables in '..\..\Units\DataBaseTables.pas',
  ConfigDoc in '..\..\Units\ConfigDoc.pas',
  SupportUnit in '..\..\Units\SupportUnit.pas',
  StandardLibs in '..\..\Units\StandardLibs.pas',
  StandardLib in '..\..\Units\StandardLib.pas',
  NewProjectFrm in '..\..\Forms\NewProjectFrm.pas' {NewProjectForm},
  ProjectFme in '..\..\Frames\ProjectFme.pas' {ProjectFrame: TFrame},
  StandardBillsDm in '..\..\DataModules\StandardBillsDm.pas' {StandardBillsData: TDataModule},
  StandardBillsFme in '..\..\Frames\StandardBillsFme.pas' {StandardBillsFrame: TFrame},
  StandardLibsFme in '..\..\Frames\StandardLibsFme.pas' {StandardLibsFrame: TFrame},
  BillsDm in '..\..\DataModules\BillsDm.pas' {BillsData: TDataModule},
  BillsMeasureFme in '..\..\Frames\BillsMeasureFme.pas' {BillsMeasureFrame: TFrame},
  Globals in '..\..\Units\Globals.pas',
  StageDm in '..\..\DataModules\StageDm.pas' {StageData: TDataModule},
  ExcelImport in '..\..\Units\ExcelImport.pas',
  CacheTree in '..\..\Units\CacheTree.pas',
  MCacheTree in '..\..\Units\MCacheTree.pas',
  ProjectPropertiesFrm in '..\..\Forms\ProjectPropertiesFrm.pas' {ProjectPropertiesForm},
  ProjectProperty in '..\..\Units\ProjectProperty.pas',
  FormulaCalc in '..\..\Units\FormulaCalc.pas',
  BillsCommand in '..\..\Units\BillsCommand.pas',
  PhaseData in '..\..\Units\PhaseData.pas',
  PhaseProperty in '..\..\Units\PhaseProperty.pas',
  BillsClipboard in '..\..\Units\BillsClipboard.pas',
  BillsTree in '..\..\Units\BillsTree.pas',
  ProjectCommands in '..\..\Units\ProjectCommands.pas',
  PhaseCompareDm in '..\..\DataModules\PhaseCompareDm.pas' {PhaseCompareData: TDataModule},
  PhaseCompareFme in '..\..\Frames\PhaseCompareFme.pas' {PhaseCompareFrame: TFrame},
  OptionFrm in '..\..\Forms\OptionFrm.pas' {OptionForm},
  DealPaymentDm in '..\..\DataModules\DealPaymentDm.pas' {DealPaymentData: TDataModule},
  DealPaymentFme in '..\..\Frames\DealPaymentFme.pas' {DealPaymentFrame: TFrame},
  PhasePayDm in '..\..\DataModules\PhasePayDm.pas' {PhasePayData: TDataModule},
  BillsGatherFme in '..\..\Frames\BillsGatherFme.pas' {BillsGatherFrame: TFrame},
  BillsGatherDm in '..\..\DataModules\BillsGatherDm.pas' {BillsGatherData: TDataModule},
  ZJJLFme in '..\..\Frames\ZJJLFme.pas' {ZJJLFrame: TFrame},
  ZJJLDm in '..\..\DataModules\ZJJLDm.pas' {ZJJLData: TDataModule},
  BGLFme in '..\..\Frames\BGLFme.pas' {BGLFrame: TFrame},
  BGLDm in '..\..\DataModules\BGLDm.pas' {BGLData: TDataModule},
  StaffDm in '..\..\DataModules\StaffDm.pas' {StaffData: TDataModule},
  ConstUnit in '..\..\Units\ConstUnit.pas',
  PHPWebDm in '..\..\DataModules\PHPWebDm.pas' {PHPWeb: TDataModule},
  uLkJSON in '..\..\Units\uLkJSON.pas',
  MergeTextFrm in '..\..\Forms\MergeTextFrm.pas' {MergeTextForm},
  BGLSelectFrm in '..\..\Forms\BGLSelectFrm.pas' {BGLSelectForm},
  WebNewTenderFrm in '..\..\Forms\WebNewTenderFrm.pas' {WebNewTenderForm},
  ExportExcel in '..\..\Units\ExportExcel.pas',
  ReportsFrm in '..\..\Forms\ReportsFrm.pas' {ReportsForm},
  ReportManager in '..\..\Units\ReportManager.pas',
  BillsCompileDm in '..\..\DataModules\BillsCompileDm.pas' {BillsCompileData: TDataModule},
  BillsCompileFme in '..\..\Frames\BillsCompileFme.pas' {BillsCompileFrame: TFrame},
  BillsMeasureDm in '..\..\DataModules\BillsMeasureDm.pas' {BillsMeasureData: TDataModule},
  PasswordInputFrm in '..\..\Forms\PasswordInputFrm.pas' {PasswordInputForm},
  AboutFrm in '..\..\Forms\AboutFrm.pas' {AboutForm},
  AuthFrm in '..\..\Forms\AuthFrm.pas' {AuthorizeForm},
  mEncryptUnit in '..\..\Encrypt\mEncryptUnit.pas',
  mEncryptPWD in '..\..\Encrypt\mEncryptPWD.pas',
  mSNSEncrypt in '..\..\Encrypt\mSNSEncrypt.pas',
  mR1Encrypt in '..\..\Encrypt\mR1Encrypt.pas',
  mEncryptEditions in '..\..\Encrypt\mEncryptEditions.pas',
  mEncryptTypes in '..\..\Encrypt\mEncryptTypes.pas',
  mConnectEncrypt in '..\..\Encrypt\NetClient\mConnectEncrypt.pas',
  CryptUtils in '..\..\Encrypt\CryptUtils.pas',
  EncryptDog in '..\..\Encrypt\EncryptDog.pas',
  ScFileArchiver in '..\..\Encrypt\ScFileArchiver.pas',
  SearchFme in '..\..\Frames\SearchFme.pas' {SearchFrame: TFrame},
  BatchInsertBillsFrm in '..\..\Forms\BatchInsertBillsFrm.pas' {BatchInsertBillsForm},
  SearchDm in '..\..\DataModules\SearchDm.pas' {SearchData: TDataModule},
  CslJson in '..\..\Units\CslJson.pas',
  FindUserFrm in '..\..\Forms\FindUserFrm.pas' {FindUserForm},
  ImportExcelHintFrm in '..\..\Forms\ImportExcelHintFrm.pas' {ImportExcelHintForm},
  CheckerFme in '..\..\Frames\CheckerFme.pas' {CheckerFrame: TFrame},
  OrderCheckerFme in '..\..\Frames\OrderCheckerFme.pas' {OrderCheckerFrame: TFrame},
  ReportAdjustFrm in '..\..\Forms\ReportAdjustFrm.pas' {ReportAdjustForm},
  DealBillsDm in '..\..\DataModules\DealBillsDm.pas' {DealBillsData: TDataModule},
  BatchReplaceBillsFrm in '..\..\Forms\BatchReplaceBillsFrm.pas' {BatchReplaceBillsForm},
  MD5Unit in '..\..\Units\MD5Unit.pas',
  MainDataListDm in '..\..\DataModules\MainDataListDm.pas' {MainListData: TDataModule},
  mProgressFrm in '..\..\Forms\mProgressFrm.pas' {mProgress},
  rmGclBillsBGDm in '..\..\DataModules\ReportMemoryDm\rmGclBillsBGDm.pas' {DataModule1: TDataModule},
  rmBGLExecutionDm in '..\..\DataModules\ReportMemoryDm\rmBGLExecutionDm.pas' {rmBGLExecutionData: TDataModule},
  rmBillsGatherDm in '..\..\DataModules\ReportMemoryDm\rmBillsGatherDm.pas' {rmBillsGatherData: TDataModule},
  rmCacheData in '..\..\DataModules\ReportMemoryDm\rmCacheData.pas',
  rmFxBillsAddDm in '..\..\DataModules\ReportMemoryDm\rmFxBillsAddDm.pas' {rmFxBillsAddData: TDataModule},
  rmFxBillsCompareDm in '..\..\DataModules\ReportMemoryDm\rmFxBillsCompareDm.pas' {rmFxBillsCompareData: TDataModule},
  rmGclBillsAddDm in '..\..\DataModules\ReportMemoryDm\rmGclBillsAddDm.pas' {rmGclBillsAddData: TDataModule},
  rmGclBillsCompareDm in '..\..\DataModules\ReportMemoryDm\rmGclBillsCompareDm.pas' {rmGclBillsCompareData: TDataModule},
  rmGridHeaderDm in '..\..\DataModules\ReportMemoryDm\rmGridHeaderDm.pas' {rmGridHeaderData: TDataModule},
  rmSelectProjectFrm in '..\..\Forms\rmSelectProjectFrm.pas' {ProjectSelectForm},
  ConditionalDefines in '..\..\Units\ConditionalDefines.pas',
  ProgressHintFrm in '..\..\Forms\ProgressHintFrm.pas' {ProgressHintForm},
  rmTestFrm in '..\..\DataModules\ReportMemoryDm\rmTestFrm.pas' {rmTestForm},
  CheckAndClearFrm in '..\..\Forms\CheckAndClearFrm.pas' {CheckAndClearForm},
  rmGclBillsAuditCompareDm in '..\..\DataModules\ReportMemoryDm\rmGclBillsAuditCompareDm.pas' {rmGclBillsAuditCompareData: TDataModule},
  DealBillsFrm in '..\..\Forms\DealBillsFrm.pas' {DealBillsForm},
  TenderBackupFrm in '..\..\Forms\TenderBackupFrm.pas' {TenderBackupForm},
  TenderBackupDm in '..\..\DataModules\TenderBackupDm.pas' {TenderBackupData: TDataModule},
  BillsBookmarkDm in '..\..\DataModules\BillsBookmarkDm.pas' {BillsBookmarkData: TDataModule},
  BookmarkFme in '..\..\Frames\BookmarkFme.pas' {BookmarkFrame: TFrame},
  rmDealInfosDm in '..\..\DataModules\ReportMemoryDm\rmDealInfosDm.pas' {rmDealInfosData: TDataModule},
  rmXmjBGLDetailDm in '..\..\DataModules\ReportMemoryDm\rmXmjBGLDetailDm.pas' {rmXmjBGLDetailData: TDataModule},
  WelcomeFrm in '..\..\Forms\WelcomeFrm.pas' {WelcomeForm},
  rmOtherReport1Dm in '..\..\DataModules\ReportMemoryDm\rmOtherReport1Dm.pas' {rmOtherReport1Data: TDataModule},
  CheckerMemoFrm in '..\..\Forms\CheckerMemoFrm.pas' {CheckerMemoForm},
  CslHint in '..\..\Units\CslHint.pas',
  TenderBackupManager in '..\..\Units\TenderBackupManager.pas',
  UpFileManageUnit in '..\..\Units\UpFileManageUnit.pas',
  UpFileFrame in '..\..\Forms\UpFileFrame.pas',
  UpFileManageFrame in '..\..\Forms\UpFileManageFrame.pas',
  SheetSelectFrm in '..\..\Forms\SheetSelectFrm.pas' {SheetSelectForm},
  Checker in '..\..\Units\Checker.pas',
  ReportInteractInfo in '..\..\Units\ReportInteractInfo.pas',
  AuditSelectFrm in '..\..\Forms\ReportInteractFrms\AuditSelectFrm.pas' {AuditSelctForm},
  DealBillsFme in '..\..\Frames\DealBillsFme.pas' {DealBillsFrame: TFrame},
  rmGclBillsPlaneDm in '..\..\DataModules\ReportMemoryDm\rmGclBillsPlaneDm.pas' {rmGclBillsPlaneData: TDataModule},
  StageCompareDm in '..\..\DataModules\StageCompareDm.pas' {StageCompareData: TDataModule},
  BGLClipboard in '..\..\Units\BGLClipboard.pas',
  rmMentalCustomized1Dm in '..\..\DataModules\ReportMemoryDm\rmMentalCustomized1Dm.pas' {rmMentalCustomized1Data: TDataModule},
  mDataRecord in '..\..\Units\mDataRecord.pas',
  rmGcl_XmjBillsDm in '..\..\DataModules\ReportMemoryDm\rmGcl_XmjBillsDm.pas' {rmGcl_XmjBillsData: TDataModule},
  rmCustomized2Dm in '..\..\DataModules\ReportMemoryDm\rmCustomized2Dm.pas' {rmCustomized2Data: TDataModule},
  CalcDecimal in '..\..\Units\CalcDecimal.pas',
  DetailExcelImport in '..\..\Units\DetailExcelImport.pas',
  mProgressProFrm in '..\..\Forms\mProgressProFrm.pas' {ProgressProForm},
  BaseClipboard in '..\..\Units\BaseClipboard.pas',
  PriceMarginBillsDm in '..\..\DataModules\PriceMarginBillsDm.pas' {PriceMarginBillsData: TDataModule},
  ProjectGLDm in '..\..\DataModules\ProjectGLDm.pas' {ProjectGLData: TDataModule},
  GclBillsGatherModel in '..\..\Units\GclBillsGatherModel.pas',
  DetailGLDm in '..\..\DataModules\DetailGLDm.pas' {DetailGLData: TDataModule},
  rmHaBaiCustomizedDm in '..\..\DataModules\ReportMemoryDm\rmHaBaiCustomizedDm.pas' {rmHaBaiCustomizedData: TDataModule},
  BillsPasteSelectFrm in '..\..\Forms\BillsPasteSelectFrm.pas' {BillsPasteSelectForm},
  PriceMarginBillsFme in '..\..\Frames\PriceMarginBillsFme.pas' {PriceMarginBillsFrame: TFrame},
  PriceMarginFme in '..\..\Frames\PriceMarginFme.pas' {PriceMarginFrame: TFrame},
  ProjectGLFme in '..\..\Frames\ProjectGLFme.pas' {ProjectGLFrame: TFrame},
  SelectDetailGLsFrm in '..\..\Forms\SelectDetailGLsFrm.pas' {SelectDetailGLsForm},
  DealPayPlanFrm in '..\..\Forms\DealPayPlanFrm.pas' {DealPayPlanForm},
  tpBaseGatherData in '..\..\TenderPartition\tpBaseGatherData.pas',
  tpGatherGcl in '..\..\TenderPartition\tpGatherGcl.pas',
  tpGatherTree in '..\..\TenderPartition\tpGatherTree.pas',
  tpMainData in '..\..\TenderPartition\tpMainData.pas',
  tpMainFrm in '..\..\TenderPartition\tpMainFrm.pas' {tpMainForm},
  tpNoPegDm in '..\..\TenderPartition\tpNoPegDm.pas' {tpNoPegData: TDataModule},
  tpPartTender in '..\..\TenderPartition\tpPartTender.pas',
  tpPartTenderFme in '..\..\TenderPartition\tpPartTenderFme.pas' {tpPartTenderFrame: TFrame},
  tpPartTenderSet in '..\..\TenderPartition\tpPartTenderSet.pas',
  tpPartTenderSetFme in '..\..\TenderPartition\tpPartTenderSetFme.pas' {tpPartTenderSetFrame: TFrame},
  tpPeg in '..\..\TenderPartition\tpPeg.pas',
  tpPeg_GclDm in '..\..\TenderPartition\tpPeg_GclDm.pas' {tpPeg_GclData: TDataModule},
  tpPeg_GclFme in '..\..\TenderPartition\tpPeg_GclFme.pas' {tpPeg_GclFrame: TFrame},
  tpPegBlock in '..\..\TenderPartition\tpPegBlock.pas',
  tpPegGclGatherDm in '..\..\TenderPartition\tpPegGclGatherDm.pas' {tpPegGclGatherData: TDataModule},
  tpPegGclGatherFme in '..\..\TenderPartition\tpPegGclGatherFme.pas' {tpPegGclGatherFrame: TFrame},
  tpPegPartSettingFrm in '..\..\TenderPartition\tpPegPartSettingFrm.pas' {tpPegPartSettingForm},
  tpPricePartSettingFrm in '..\..\TenderPartition\tpPricePartSettingFrm.pas' {tpPricePartSettingForm},
  tpSelectTenderDm in '..\..\TenderPartition\tpSelectTenderDm.pas' {tpSelectTenderData: TDataModule},
  tpSelectTenderNode in '..\..\TenderPartition\tpSelectTenderNode.pas',
  tpSelectTendersFrm in '..\..\TenderPartition\tpSelectTendersFrm.pas' {SelectTendersForm},
  tpTrialPegInputFrm in '..\..\TenderPartition\tpTrialPegInputFrm.pas' {TrialPegInputForm},
  mPegFilter in '..\..\Units\mPegFilter.pas';

{$R *.res}

var Mutex: THandle;
begin
  Mutex := CreateMutex(nil, True, G_AppHandleName);

  if GetLastError = ERROR_ALREADY_EXISTS then
    Application.MessageBox(', ظ򿪸', 'ϵͳʾ', MB_OK + MB_ICONINFORMATION)
  else
  begin
    Application.CreateHandle;
    Application.Initialize;
    Application.Title := 'ݺṫ·̽һ廯㶫רҵ';
    ShowWelcome;
    if CheckDogExists then
    begin
      HideWelcome;
      Application.CreateForm(TMainForm, MainForm);
    end
    else  HideWelcome;
    Application.Run;
  end;

  ReleaseMutex(Mutex);
end.
