//------------------------------------------------------------------------------
//  :   TCslJson
//
//  :   򵥵Jsonַ
//          Ϊ򻯲JsonַĸʽһҪ
//          ټֲظڼֵȫַʽ£
//          {"status":"true","msg":{"curr":"1","status2":"\u5ba1\u6838\u4e2d",
//          "name":"麣ݺ"}}
//
//          ҹJsonؼãиlkJsonĸտʼ
//          룬ԽԽࣺǶ顢ķʽ
//          ӽ㣨ʼշNullDelphiתַѵ⡣Щ
//          Jsonؼ(superobject1.24)ֻ֧Delphi XEȸ߰汾, ΪЩ﷨
//          Delphi7в֧֡Integer overflowȡ̫⣬ΣԼд
//          򵥵Ľеɽկܽ⡣пдרҵġ
//
//  :   Chenshilong, 2014-07-03
//------------------------------------------------------------------------------


unit CslJson;

interface

uses
  SysUtils, Classes, Dialogs;

type
  TOVArr = array of array of string;   // ObjectValuesArray

  TCslJson = class
  private
    FText: string;
    FOVArr: TOVArr;

    procedure SetText(const Value: string);
    function GetValue(const AField: string): string;
    // תַ
    function Transfer(AStr: string): string;

  public
    property Text: string read FText write SetText;
    // ȡֵָļֵֵǸ򷵻{Object}
    // ֵ"Ŷȷһɷֵַ͡ΪղӰ
    // ûת⡣
    property Value[const AField: string]: string read GetValue;
    // ֵָļֵǸѶÿֵAArrayС
    // AArray±⣬Ԫظ⣨
    procedure ChildValues(AField: string; var AArray: array of string);

    function ArrayText(AField: string): string;               // Jsonάлֵַ
    function ArrayElementCount(AField: string): Integer;     // JsonάԪظ
    function ArrayElementText(AField: string; AIndex: Integer): string;  //  JsonάĵAIndexԪصֵַ
    function ArrayElementPropertyCount(AElementText: string): Integer;   //  JsonάԪصļֵԸ
    function ArrayValues(AField: string): TOVArr;

  end;

implementation


{ TcslJson }

procedure TCslJson.SetText(const Value: string);
begin
  FText := Value;
end;

function TCslJson.GetValue(const AField: string): string;
var sF: string;
  iPos, iCur: Integer;
begin
  Result := '';
  if AField = '' then Exit;
  sF := Format('"%s":', [AField]);
  iPos := POS(sF, FText);
  if iPos = 0 then Exit;

  iCur := iPos + Length(sF);
  iPos := iCur;
  while (FText[iCur] <> ',') and (FText[iCur] <> '}') do
    Inc(iCur);
  Result := Copy(FText, iPos, iCur - iPos);
  if Pos('{', Result) > 0 then
  begin
    Result := '{Object}';
    Exit;
  end;
  Result := StringReplace(Result, '"', '', [rfReplaceAll]);
  Result := Transfer(Result);
end;

procedure TCslJson.ChildValues(AField: string; var AArray: array of string);
var sField, sText, sValue: string;
  iPos, iCur, i, j: Integer;
  vSL: TStringList;
begin
  if AField = '' then Exit;
  sField := Format('"%s":', [AField]);
  iPos := POS(sField, FText);
  if iPos = 0 then Exit;

  iCur := iPos + Length(sField);
  iPos := iCur;
  while (FText[iCur] <> '}') do
    Inc(iCur);
  sText := Copy(FText, iPos, iCur - iPos);
  sText := StringReplace(sText, '{', '', []);      // ȥһ"{"
  if Pos('{', sText) > 0 then                      // ֤ǶӶ󣬲֧
  begin
      AArray[Low(AArray)] := '{Contain Sub Object}';
      Exit;
  end;

  // "curr":"1","status2":"\u5ba1\u6838\u4e2d","total":"1","name":"麣ݺ"
  vSL := TStringList.Create;
  try
    while Length(sText) > 0 do
    begin
      iPos := POS(':"', sText);
      iCur := iPos + 2;
      iPos := iCur;
      while (sText[iCur] <> '"') do
        Inc(iCur);

      sValue := Copy(sText, iPos, iCur - iPos);
      sValue := Transfer(sValue);
      vSL.Add(sValue);

      iCur := iCur + 2;
      sText := Copy(sText, iCur, Length(sText) - iCur + 1);
    end;

    // ַʽ֤±⣬Ԫظ⣬
    j := 1;
    for i := Low(AArray) to High(AArray) do
    begin
      if J > vSL.Count then Break;
      AArray[i] := vSL[j - 1];
      Inc(j);
    end;

  finally
    vSL.Free;
  end;
end;

function TCslJson.Transfer(AStr: string): string;
begin
  AStr := StringReplace(AStr, '\/', '\', [rfReplaceAll]);   // ·еġ\/
  Result := AStr;
end;

function TCslJson.ArrayText(AField: string): string;
var sField: string;
  iPos, iCur: Integer;
begin
  Result := '';

  if AField = '' then Exit;
  sField := Format('"%s":[', [AField]);
  iPos := POS(sField, FText);
  if iPos = 0 then Exit;

  iCur := iPos + Length(sField);
  iPos := iCur;
  while (FText[iCur] <> ']') do
    Inc(iCur);
  Result := Copy(FText, iPos, iCur - iPos);
end;

function TCslJson.ArrayElementText(AField: string; AIndex: Integer): string;
var sAT: string;
  iLen, i, iCount, iPos1, iPos2: Integer;
begin
  Result := '';
  iCount := 0;
  iPos1 := 0;
  iPos2 := 0;

  sAT := ArrayText(AField);
  iLen := Length(sAT);

  for i := 1 to iLen do
  begin
    if sAT[i] = '{' then
    begin
      Inc(iCount);
      if iCount = AIndex then
      begin
        iPos1 := i;
        Break;
      end;
    end;
  end;

  for i := iPos1 to iLen do
  begin
    if sAT[i] = '}' then
    begin
      iPos2 := i;
      Break;
    end;
  end;
  Result := Copy(sAT, iPos1, iPos2 - iPos1 + 1);

end;  

function TCslJson.ArrayElementCount(AField: string): Integer;
var i, iLen: Integer;
  sAText: string;
begin
  Result := 0;
  sAText := ArrayText(AField);
  iLen := Length(sAText);
  for i := 1 to iLen do
  begin
    if sAText[i] = '}' then
      Inc(Result);
  end;
end;

function TCslJson.ArrayElementPropertyCount(AElementText: string): Integer;
var i, iLen: Integer;
begin
  Result := 1;

  iLen := Length(AElementText);
  for i := 1 to iLen do
  begin
    if AElementText[i] = ',' then
      if (i < iLen) and (AElementText[i + 1] = '"') then
        Inc(Result);
  end;
end;

function TCslJson.ArrayValues(AField: string): TOVArr;
var sText: string;
  iPos, iCur, i, j, iECount, iPCount: Integer;
  vSL: TStringList;
begin
  Result := nil;
  if AField = '' then Exit;
  iECount := ArrayElementCount(AField);
  if iECount = 0 then Exit;
  iPCount := ArrayElementPropertyCount(ArrayElementText(AField, 1));

  SetLength(FOVArr, iECount, iPCount);

  vSL := TStringList.Create;
  try
    for i := 1 to iECount do
    begin
      sText := ArrayElementText(AField, i);
      vSL.Clear;
      while Length(sText) > 0 do
      begin
        iPos := POS(':"', sText);
        iCur := iPos + 2;
        iPos := iCur;
        while (sText[iCur] <> '"') do
          Inc(iCur);

        vSL.Add(Transfer(Copy(sText, iPos, iCur - iPos)));

        iCur := iCur + 2;
        sText := Copy(sText, iCur, Length(sText) - iCur + 1);
      end;

      for j := 0 to vSL.Count - 1 do
      begin
        FOVArr[i - 1, j] := vSL[j];
      end;
    end;
  finally
    vSL.Free;
  end;
  Result := FOVArr;
end;




end.

 
